package org.wfc.omada.api.device.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * ModelUpgradeInfo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:26:25.576+08:00[Asia/Shanghai]")

public class ModelUpgradeInfo   {
  @JsonProperty("modelList")
  @Valid
  private List<String> modelList = new ArrayList<>();

  @JsonProperty("selectType")
  private String selectType;

  public ModelUpgradeInfo modelList(List<String> modelList) {
    this.modelList = modelList;
    return this;
  }

  public ModelUpgradeInfo addModelListItem(String modelListItem) {
    this.modelList.add(modelListItem);
    return this;
  }

  /**
   * The selected model list.
   * @return modelList
  */
  @ApiModelProperty(required = true, value = "The selected model list.")
  @NotNull


  public List<String> getModelList() {
    return modelList;
  }

  public void setModelList(List<String> modelList) {
    this.modelList = modelList;
  }

  public ModelUpgradeInfo selectType(String selectType) {
    this.selectType = selectType;
    return this;
  }

  /**
   * SelectType should be a value as follows: all: select all; include: include selected modelList; exclude: all but exclude selected modelList.
   * @return selectType
  */
  @ApiModelProperty(required = true, value = "SelectType should be a value as follows: all: select all; include: include selected modelList; exclude: all but exclude selected modelList.")
  @NotNull


  public String getSelectType() {
    return selectType;
  }

  public void setSelectType(String selectType) {
    this.selectType = selectType;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ModelUpgradeInfo modelUpgradeInfo = (ModelUpgradeInfo) o;
    return Objects.equals(this.modelList, modelUpgradeInfo.modelList) &&
        Objects.equals(this.selectType, modelUpgradeInfo.selectType);
  }

  @Override
  public int hashCode() {
    return Objects.hash(modelList, selectType);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ModelUpgradeInfo {\n");
    
    sb.append("    modelList: ").append(toIndentedString(modelList)).append("\n");
    sb.append("    selectType: ").append(toIndentedString(selectType)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

